%{
    #include <stdio.h>
    extern void yyerror(char*);
%}

%token SELECT FROM WHERE AND NAMN TEXT TAL KOMMA SEMIKOLON LE GE LT GT EQ NE
%define parse.error verbose
%start kommando

%%

kommando : SELECT namnlista FROM namnlista valfritt_villkor SEMIKOLON ;

namnlista : namnlista KOMMA NAMN | NAMN ;

valfritt_villkor : WHERE villkor | /* Tomt */ ;

villkor : villkor AND delvillkor | delvillkor ;

delvillkor : operand operator operand ;

operand : NAMN | TAL | TEXT ;

operator : LE | GE | LT | GT | EQ | NE ;

%%

int main() {
    printf("Mata in en SQL-fråga. Avsluta med semikolon.\n");
    yyparse();
    printf("Klart!\n");
    return 0;
}

void yyerror(char *s) {
    printf("Ogiltig SQL-fråga! Felmeddelande: %s\n", s);
}

int yywrap(void) {
    return 1;
}
